# 0. INSTALL/ASSERT PREREQ #1: MongoDB

# 3 stanzas moved up to main.yml, so Debian finishes "BIG-sized" IIAB install
# (WITH LOUD RED WARNINGS!)


# 1. INSTALL/ASSERT PREREQ #2: Node.js

- name: "Set 'nodejs_install: True' and 'nodejs_enabled: True'"
  set_fact:
    nodejs_install: True
    nodejs_enabled: True

- name: NODEJS - run 'nodejs' role (attempt to install & enable Node.js)
  include_role:
    name: nodejs

- name: FAIL (STOP THE INSTALL) IF 'nodejs_installed is undefined'
  fail:
    msg: "Sugarizer install cannot proceed, as Node.js is not installed."
  when: nodejs_installed is undefined

# 2020-10-29: No longer nec as Sugarizer works on most all versions of Node.js
#- name: FAIL (STOP THE INSTALL) IF 'nodejs_version != "12.x"'
#  fail:
#    msg: "Sugarizer install cannot proceed, as it currently requires Node.js 12.x, whereas nodejs_version is set to {{ nodejs_version }}.  Please check the value of nodejs_version in /opt/iiab/iiab/vars/default_vars.yml, /etc/iiab/local_vars.yml, /opt/iiab/iiab/roles/nodejs, etc."
#  when: nodejs_version != "12.x"


# 2. DOWNLOAD+LINK /opt/iiab/sugarizer

- name: Clone llaske/sugarizer ({{ sugarizer_git_version }} branch/version) from GitHub to /opt/iiab/{{ sugarizer_dir_version }} (MAY DOWNLOAD 600+ MB)
  git:
    repo: https://github.com/llaske/sugarizer
    dest: "{{ iiab_base }}/{{ sugarizer_dir_version }}"
    version: "{{ sugarizer_git_version }}"
    force: yes
    depth: 1
  when: internet_available

- name: Symlink /opt/iiab/sugarizer -> /opt/iiab/{{ sugarizer_dir_version }}
  file:
    src: "{{ iiab_base }}/{{ sugarizer_dir_version }}"
    dest: "{{ iiab_base }}/sugarizer"
    state: link


# 3. DOWNLOAD+LINK /opt/iiab/sugarizer-server

# 2018-07-11: http://download.iiab.io/packages/sugarizer-server-1.0.tar.gz
# was flawed, as documented at:
#    https://github.com/iiab/iiab/pull/814#issuecomment-404211098
# Versions of MongoDB, npm (& Node.js ?) matter!  Sugarizer 1.0 Context:
#    https://github.com/iiab/iiab/issues/798
# Going forward let's "git clone" IIAB's preferred versions, of sugarizer
# AND sugarizer-server, as specified in roles/sugarizer/defaults/main.yml

# 2018-07-14 BLOAT: git works well BUT even with "depth: 1"
# - 229MB is unfort downloaded to /opt/iiab/sugarizer/.git
# - 1.4MB is unfort downloaded to /opt/iiab/sugarizer-server/.git

# CLARIF: during repeat runs of "./runrole sugarizer", this git sync shows
# "changed" (whereas above git sync shows "ok").  Reason: "npm install"
# (below) modifies /opt/iiab/sugarizer-server/node_modules
- name: Clone llaske/sugarizer-server ({{ sugarizer_server_git_version }} branch/version) from GitHub to /opt/iiab/{{ sugarizer_server_dir_version }}
  git:
    repo: https://github.com/llaske/sugarizer-server
    dest: "{{ iiab_base }}/{{ sugarizer_server_dir_version }}"
    version: "{{ sugarizer_server_git_version }}"
    force: yes
    depth: 1
  when: internet_available

- name: Symlink /opt/iiab/sugarizer-server -> /opt/iiab/{{ sugarizer_server_dir_version }}
  file:
    src: "{{ iiab_base }}/{{ sugarizer_server_dir_version }}"
    dest: "{{ iiab_base }}/sugarizer-server"
    state: link


# 4. RUN "npm install" TO POPULATE ~35MB /opt/iiab/sugarizer-server/node_modules (TWICE, BIG JOB THEN SMALL JOB)

# Re-running "npm install" USED TO fail on Raspbian 9 if not other OS's ?
# Strategies considered to avoid re-running it:
# OLD WAY 1: test & set flag node_modules_exists: True
# OLD WAY 2: "creates: ..." checks for non-existence of /opt/iiab/sugarizer-server-1.0/node_modules
# OLD WAY 3: set "register: git_sug_server_output" above, then as nec delete /opt/iiab/sugarizer-server-1.0/node_modules "when: git_sug_server_output.changed" and as nec run "npm install"

#- name: Check for /opt/iiab/sugarizer-server/node_modules
#  stat:
#    path: "{{ iiab_base }}/sugarizer-server/node_modules"
#  register: nmtest
#  ignore_errors: True
#
#- name: Set a flag to prevent re-running of "npm install"
#  set_fact:
#    node_modules_exists: True
#  when: nmtest.stat is defined and nmtest.stat.exists

# NEW WAY BELOW: run "npm install --allow-root" every time, as modern versions
# of npm are incremental, with sanity checks (all 3 may work: but npm 6.2.0
# is better than 5.6.0. which is better than Ubuntu 18.04's 3.5.2).

# 2018-07-15: TK Kang & Holt confirmed sudo-driven "npm install" maxes out CPU
# for hours, on diff OS's using npm 5.6.0 and 6.2.0.  Hours later you may get
# error: code EACCES, errno -13 (permission denied),
# "Missing write access to /opt/iiab/sugarizer-server-1.0/node_modules"
#
# SOLUTION: Implement '--allow-root --unsafe-perm=true' below, as is critical
# for 1st run of sudo-driven 'npm install' especially:
#
# ON DEBIAN: npm 5.6.0's --allow-root would be sufficient: causing creation
# of /root/.npm cache & lock files to owned by root:root instead of
# iiab-admin:iiab-admin...thus permitting it & IIAB installs to complete!
#
# ON RASPBIAN: npm 5.6.0's --unsafe-perm=true is *required* so that npm
# install actually finished (in about 5 minutes).  It's possible we should
# remove --allow-root in favor of --unsafe-perm=true alone.  But this needs
# testing on different Linuxes before proceeding.
#
# CLARIF 1: Something like 'chown -R root:root /root/.npm' would do the job,
# but cannot happen synchronously throughout the 1st run of 'npm install'
# (when it's needed!)  Similar to what --allow-root does on Debian.
#
# CLARIF 2: Ubuntu 18.04 is currently unaffected due to its ancient
# npm 3.5.2, which instead uses /home/iiab-admin/.npm (which remains owned
# by iiab-admin:iiab-admin, even with '--allow-root', but thankfully still
# gets the job done, for now!)

#- name: Create the express framework for Node.js (OS's other than Fedora 18)
- name: Run 'npm install --allow-root --unsafe-perm=true' to create /opt/iiab/sugarizer-server/node_modules (CAN TAKE ~10 MINUTES)
  command: npm install --allow-root --unsafe-perm=true    # "command:" a bit safer than "shell:"
  args:
    chdir: "{{ iiab_base }}/sugarizer-server"
    #creates: "{{ iiab_base }}/sugarizer-server/node_modules"    # OLD WAY 2
  when: internet_available    # "npm install" generally requires Internet access
# when: internet_available and git_sug_server_output.changed    # OLD WAY 3
# when: internet_available and not is_F18 and not node_modules_exists    # OLD WAY 1

# Add a Node.js Express function that appends a prefix to URLs.
# SEE "AUTO-INSERTED BY IIAB" ~61 LINES BELOW: as those two "pathPrefix" lines
# MUST be added to /opt/iiab/sugarizer-server/sugarizer.js
- name: For http://box/sugarizer -- run 'npm install --allow-root --unsafe-perm=true path-prefix-proxy' to create /opt/iiab/sugarizer-server/node_modules/path-prefix-proxy
  command: npm install --allow-root --unsafe-perm=true path-prefix-proxy
  args:
    chdir: "{{ iiab_base }}/sugarizer-server"
  when: internet_available


# 5. CONFIG FILES

- name: "Install from template: /etc/systemd/system/sugarizer.service"
  template:
    src: sugarizer.service
    dest: /etc/systemd/system

- name: systemctl daemon_reload, so systemd (re)reads sugarizer.service
  systemd:
    daemon_reload: yes

# 2020-10-30: PR #2604 tries a cleaner layout, with NGINX only
#- name: "Install from template: /etc/{{ apache_conf_dir }}/sugarizer.conf"
#  template:
#    src: sugarizer.conf.j2
#    dest: "/etc/{{ apache_conf_dir }}/sugarizer.conf"    # apache2/sites-available
#  when: apache_installed is defined

# 3 [WAS 4] STANZAS ADDED BELOW JAN/FEB 2019, HOPING THIS MIGHT "JUST WORK"
# WITH FUTURE UPGRADES BEYOND SUGARIZER 1.1?!
#
# SOME BACKGROUND -- WHY WE'RE AUTO-EDITING sugarizer-server'S CONFIG FILES:
# http://github.com/iiab/iiab/pull/1430#issuecomment-459129378

# sugarizer_port is set to 8089 in /opt/iiab/iiab/vars/default_vars.yml
# If you need to change this, edit /etc/iiab/local_vars.yml prior to installing
- name: Set Sugarizer port to {{ sugarizer_port }} in /opt/iiab/sugarizer-server/env/sugarizer.ini
  lineinfile:
    path: "{{ iiab_base }}/sugarizer-server/env/sugarizer.ini"
    regexp: '^port = 8080$'
    line: "port = {{ sugarizer_port }}"

# 2019-02-02 No Longer Required thanks to @llaske's upstream fix:
# https://github.com/llaske/sugarizer-server/commit/46c4822bc7801ff8d621c22988aa4418359e7e19
## 2019-02-02: HACK WAS REQUIRED ON UBUNTU 18.04 so Sugarizer finds MongoDB
## after 1st reboot.  Otherwise "Waiting for DB..." appears every second as
## shown by "systemctl status sugarizer" and "journalctl -eu sugarizer".
## This does NOT affect Ubuntu 16.04 or Raspbian.  @jvonau wonders if U18.04's
## "nameserver 127.0.0.53" in /etc/resolv.conf is to blame?  @m-anish wondered
## if "bind_ip: 127.0.0.1" in /etc/mongod.conf was to blame as suggested by
## https://stackoverflow.com/questions/8904991/mongodb-cant-connect-to-localhost-but-can-connect-to-localhosts-ip-address
## But changing to "bind_ip: localhost" does not work with Sugarizer, and
## "bind_ip: 127.0.0.1,localhost" is not allowed.  BACKGROUND: PR #1430
#- name: Set MongoDB "server" from localhost to 127.0.0.1 in /opt/iiab/sugarizer-server/env/sugarizer.ini
#  lineinfile:
#    path: "{{ iiab_base }}/sugarizer-server/env/sugarizer.ini"
#    regexp: '^server = localhost$'
#    line: "server = 127.0.0.1"

# mongodb_port is set to 27017 in /opt/iiab/iiab/vars/default_vars.yml
# If you must change this, it's best to edit /etc/iiab/local_vars.yml prior to
# installing IIAB.  Please also see upstream recommendations:
# https://github.com/llaske/sugarizer-server/blob/master/env/sugarizer.ini line ~22 under [database]
# https://docs.mongodb.com/manual/reference/default-mongodb-port/
# https://www.iana.org/assignments/service-names-port-numbers/service-names-port-numbers.txt
- name: Set MongoDB port to {{ mongodb_port }} in /opt/iiab/sugarizer-server/env/sugarizer.ini
  lineinfile:
    path: "{{ iiab_base }}/sugarizer-server/env/sugarizer.ini"
    regexp: '^port = 27017$'    # Careful as file also contains 2 other ports!
    line: "port = {{ mongodb_port }}"

# 2-LINE FIX FOR sugarizer.js BY @georgejhunt FOR http://box/sugarizer
# SEE ~61 LINES ABOVE, as this is REQUIRED: 'npm install --allow-root --unsafe-perm=true path-prefix-proxy'
# OR YOU GET ERRORS: "status=255" within "systemctl status sugarizer"
#                    "Cannot find module 'path-prefix-proxy'" within "journalctl -eu sugarizer"
- name: For http://box/sugarizer -- add pathPrefix lines in /opt/iiab/sugarizer-server/sugarizer.js
  lineinfile:
    path: "{{ iiab_base }}/sugarizer-server/sugarizer.js"
    regexp: 'AUTO-INSERTED BY IIAB'    # avoids inserting it twice!
    insertbefore: "// Start listening$"
    line: |    # SEE https://yaml-multiline.info (use |+ to 'keep' newlines at end...though |8 and |+4 "indentation indicators" don't work with Ansible)
      // AUTO-INSERTED BY IIAB FOR http://box/sugarizer
      var pathPrefix = '/sugarizer';
      app.use(pathPrefix, require('path-prefix-proxy')(pathPrefix));
    # Use this instead, if tabs are truly nec:
    # line: "\t// AUTO-INSERTED BY IIAB FOR http://box/sugarizer\n\tvar pathPrefix = '/sugarizer';\n\tapp.use(pathPrefix, require('path-prefix-proxy')(pathPrefix));\n"

# Ansible's blockinfile module:
# - inserts a mandatory marker line at beginning AND end of the block...ok fine
# - doesn't support adding a newline after the block...ugly :(
# - doesn't include above lineinfile's "regexp" parameter...and so risks inserting the block repeatedly, on each run :(
#
#  blockinfile:
#    path: /opt/iiab/sugarizer-server/sugarizer.js
#    insertbefore: "// Start listening$"
#    marker: "// {mark} AUTO-INSERTED BY IIAB FOR http://box/sugarizer"
#    block: |
#      var pathPrefix = '/sugarizer';
#      app.use(pathPrefix, require('path-prefix-proxy')(pathPrefix));
#    # Use this instead, if tabs are truly nec:
#    # block: "\tvar pathPrefix = '/sugarizer';\n\tapp.use(pathPrefix, require('path-prefix-proxy')(pathPrefix));"


# 6. RECORD Sugarizer AS INSTALLED

- name: "Set 'sugarizer_installed: True'"
  set_fact:
    sugarizer_installed: True

- name: "Add 'sugarizer_installed: True' to {{ iiab_state_file }}"
  lineinfile:
    path: "{{ iiab_state_file }}"    # /etc/iiab/iiab_state.yml
    regexp: '^sugarizer_installed'
    line: 'sugarizer_installed: True'
